/*
 I.T.T. Cerulli Giulianova
 Dip: Elettronica -Elettronica 
 Lab: T.D.P./T.P.S.
 Esempio controllo temperatura di un caseificio
 LCD usato 20 X 4 Marca: CTC modello: CMC420N01
 RTC usato DS3231
 
 The circuit:
 * LCD RS pin to digital pin 9
 * LCD Enable pin to digital pin 8
 * LCD D4 pin to digital pin 7
 * LCD D5 pin to digital pin 6
 * LCD D6 pin to digital pin 5
 * LCD D7 pin to digital pin 4
 * LCD R/W pin to ground GND
 * 10K resistor:
   * ends to +5V (VDD pin 2 LCD) and ground (VSS pin 1 LCD)
   * wiper to LCD VO pin (pin 3)
   * pin 13 arduino relè (dispositivo reffreddante)
   * pin 12 arduino allarme sonoro (buzzer)
   * pin A0 ingresso sensore LM 35
 
 realizzato dal prof. Benignetti e dagli studenti 
 Pawel Kowalewski e Edoardo Di Fabio 
 latest modified: 25 Mar 2015
 
 This example and code is in the public domain.
 http://www.francescobenignetti.it/robotica/arduino/

 */


#include <LiquidCrystal.h> //Includi Libreria Display LCD
#include <DS3231.h> //Includi Libreria RTC
#include <Wire.h> //Includi I2C
LiquidCrystal lcd(9, 8, 7, 6, 5, 4); //Dichiara PIN LCD
float tempLM35; //Variabile con virgola della temperatura
DS3231 Clock; //Inizializza il conteggio dell'ora
bool Century=false; //
bool h12;           // Variabili booleane per il controllo del tipo di ora   
bool PM;            //
byte ADay, AHour, AMinute, ASecond, ABits; // Variabili Del conteggio del tempo
bool ADy, A12h, Apm;// Variabile booleana per il controllo del tipo di ora   

byte year, month, date, DoW, hour, minute, second;// Variabili Del conteggio del tempo

void setup() {
  lcd.begin(20, 4); //Inizializza il display di 20 colonne per 4 righe   
  Wire.begin(); //Inizializza I2C
  analogRead (A0); //Leggi inizialmente la porta A0
  pinMode (12,OUTPUT); // Dichiara pin in Uscita 12
  pinMode (13,OUTPUT);// Dichiara pin in Uscita 13
  Serial.begin(115200);// Inizializza la Seriale
}
 
 void ReadDS3231() //Funzione di lettura RTC
{
  int second,minute,hour,date,month,year,temperature; 
  second=Clock.getSecond();
  minute=Clock.getMinute();
  hour=Clock.getHour(h12, PM);
  date=Clock.getDate();
  month=Clock.getMonth(Century);
  year=Clock.getYear();
  
  temperature=Clock.getTemperature(); //Acquisisci la temperatura dal modulo RTC
  
  Serial.print("20");
  Serial.print(year,DEC);
  Serial.print('-');
  Serial.print(month,DEC);
  Serial.print('-');
  Serial.print(date,DEC);
  Serial.print(' ');
  Serial.print(hour,DEC);
  Serial.print(':');
  Serial.print(minute,DEC);   //Scrivi sull'LCD e sulla Seriale Data e Ora
  Serial.print(':');
  Serial.print(second,DEC);
  Serial.print('\n');
  Serial.print("Temperature=");
  Serial.print(temperature); 
  Serial.print('\n');
  lcd.setCursor(0, 2);
  lcd.print(hour,DEC);
  lcd.print(':');
  lcd.print(minute,DEC);
  lcd.print(':');
  lcd.print(second,DEC);
  lcd.setCursor(10, 2);
  lcd.print(date,DEC);
  lcd.print('/');
  lcd.print(month,DEC);
  lcd.print('/');
  lcd.print("20");
  lcd.print(year,DEC);
  lcd.setCursor (0,0);
  lcd.print ("TEMPERATURA di:  ");
  lcd.setCursor (0,1);
  lcd.print (tempLM35);   //Scrivi sul display la temperatura letta da LM35
  lcd.print  ( (char) 223);
  lcd.print (  'C'   );
}

void loop() {
  
  ReadDS3231();
  delay(1000); // Leggi ogni secondo la data e ora del RTC

start://Riferimento goto
  lcd.clear(); //pulisci il display
  ReadDS3231(); // Leggi ogni secondo la data e ora del RTC
  delay(100);// aspetta 100 ms

 
  tempLM35 = (5.0 * analogRead (A0) * 100) / 1023;// Leggi la temperatura in funzione della tensione ricevuta dal sensore LM35

  
  if (tempLM35>=22.50) // ciclo di controllo ridondante della temperatura di intervento elettroventola ON
{digitalWrite (13,HIGH);
 }

  else if (tempLM35<22.50)
{delay (250); digitalWrite (13,LOW);
 } // ciclo di controllo ridondante della temperatura di intervento elettroventola OFF

if (tempLM35>=25)  // ciclo di controllo della temperatura di allarme con intervento del cicalino

{
  
 lcd.setCursor (0,4); // Setta il cursore del display
 lcd.print ("Verificare guasto"); //Visualizza avviso guasto sul display
 tone (12, 2500, 100);      // Generatore tono di allarme
 delay (100);
 tone (12, 2000, 200);
 delay(100);
 noTone(12);
}

else 
{ 
 lcd.setCursor (0,4);
 lcd.print ("                 "); //Cancella la scritta d'allarme se non è necessario visualizzarla

  goto start; //Torna a start
}


}

